# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
#
# Code generated by aaz-dev-tools
# --------------------------------------------------------------------------------------------

from foundationallm.cli.core import AzCommandsLoader
from fllmext_fllm._help import helps  # pylint: disable=unused-import


class FllmCommandsLoader(AzCommandsLoader):

    def __init__(self, cli_ctx=None):
        from foundationallm.cli.core.commands import CliCommandType
        custom_command_type = CliCommandType(
            operations_tmpl='azext_fllm.custom#{}')
        super().__init__(cli_ctx=cli_ctx,
                         custom_command_type=custom_command_type)

    def load_command_table(self, args):
        from fllmext_fllm.commands import load_command_table
        from foundationallm.cli.core.aaz import load_aaz_command_table
        try:
            from . import aaz
        except ImportError:
            aaz = None
        if aaz:
            load_aaz_command_table(
                loader=self,
                aaz_pkg_name=aaz.__name__,
                args=args
            )
        load_command_table(self, args)
        return self.command_table

    def load_arguments(self, command):
        from fllmext_fllm._params import load_arguments
        load_arguments(self, command)


COMMAND_LOADER_CLS = FllmCommandsLoader
